## ----------------------------------------------------------------------------
## Baltagi (2005)
##
## data
## availability: electronic
## firms: General Motors, US Steel, General Electric, Chrysler, Atlantic Refining,
##        IBM, Union Oil, Westinghouse, Goodyear, Diamond Match
## errors: none
##
## analysis
## result: exact at precision given
## ----------------------------------------------------------------------------

## preliminaries
source("start.R")

## data pre-processing
gr <- subset(Grunfeld, firm %in% c("General Motors", "US Steel", "General Electric", "Chrysler",
  "Atlantic Refining", "IBM", "Union Oil", "Westinghouse", "Goodyear", "Diamond Match"))
gr$firm <- factor(gr$firm)
pgr <- plm.data(gr, c("firm", "year"))

## Panel models: OLS / Between / Within / RE (Example 2.6.1, p. 21)
plm_pool    <- plm(invest ~ value + capital, data = pgr, model = "pooling")
## or: lm(invest ~ value + capital, data = pgr)
plm_between <- plm(invest ~ value + capital, data = pgr, model = "between")
plm_within  <- plm(invest ~ value + capital, data = pgr, model = "within")
plm_walhus  <- plm(invest ~ value + capital, data = pgr, model = "random", random.method = "walhus")
plm_amemiya <- plm(invest ~ value + capital, data = pgr, model = "random", random.method = "amemiya")
plm_swarmy  <- plm(invest ~ value + capital, data = pgr, model = "random", random.method = "swar")

gsummary(plm_pool)
gsummary(plm_between)
gsummary(plm_within)
gsummary(plm_walhus)
gsummary(plm_amemiya)
gsummary(plm_swarmy)
