## ----------------------------------------------------------------------------
## Swamy (1970)
##
## data
## availability: none
## firms: General Motors, US Steel, General Electric, Chrysler, Atlantic Refining,
##        IBM, Union Oil, Westinghouse, Goodyear, Diamond Match, American Steel
## errors: claims to use all firms and that data are from Boot and de Wit 1960,
## but this is impossible given that they only have 10 firms.
##
## analysis
## result: uses all 11 firms
## ----------------------------------------------------------------------------


## Sect. 7
## test stat. given below (7.3) claims to use F_(20,187) crit. value 
## but this should perhaps be F_(20,198) according to theory on p. 319 
## if data are demeaned (Lambda=2 vs Lambda=3)

source("start.R")

gr <- Grunfeld
gr$firm <- factor(gr$firm)
pgr <- plm.data(gr, c("firm", "year"))

## RCM without demeaning:
fm_rcm <- pvcm(invest ~ value + capital, model = "random", data = pgr)
summary(fm_rcm)
coeftest(fm_rcm)[2:3, 1:2]

## demeaning
pgrd <- pgr
pgrd[,3:5] <- with(pgr, apply(pgr[,3:5], 2, function(x) resid(lm(x ~ firm))))

## RCM with demeaning (without constant)
fm_rcmd <- pvcm(invest ~ 0 + value + capital, model = "random", data = pgrd)
summary(fm_rcmd)
coeftest(fm_rcmd)[, 1:2]
